new file mode 100755
@@ -0,0 +1,62 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (C) 2019 SUSE Linux Products GmbH. All Rights Reserved.
+#
+# FS QA Test 180
+#
+# Test if btrfs hits EDQUOT without reclaiming already freed extents when quota
+# is enabled.
+#
+# This bug is going to be fxied by a patch for kernel titled
+# "btrfs: qgroup: Make qgroup async transaction commit more aggressive"
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+_require_xfs_io_command falloc
+
+_scratch_mkfs > /dev/null
+_scratch_mount
+
+$BTRFS_UTIL_PROG quota enable "$SCRATCH_MNT" > /dev/null
+$BTRFS_UTIL_PROG quota rescan -w "$SCRATCH_MNT" > /dev/null
+$BTRFS_UTIL_PROG qgroup limit -e 1G "$SCRATCH_MNT"
+
+$XFS_IO_PROG -f -c "falloc 0 900M" "$SCRATCH_MNT/padding"
+
+# Commit transaction to reflect the quota usage
+sync
+
+rm -f "$SCRATCH_MNT/padding"
+
+# Without the kernel fix, this will trigger EDQUOT.
+_pwrite_byte 0xcd 0 512M "$SCRATCH_MNT/real_file" | _filter_xfs_io
+
+# success, all done
+status=0
+exit
new file mode 100644
@@ -0,0 +1,3 @@
+QA output created by 180
+wrote 536870912/536870912 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
@@ -182,3 +182,4 @@
177 auto quick swap balance
178 auto quick send
179 auto qgroup dangerous
+180 auto quick qgroup limit